#ifndef _GLOBAL_H_
#define _GLOBAL_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int   u32;

#include "gp2x_psp.h"
#include <time.h>

# ifndef CLK_TCK
# define CLK_TCK  CLOCKS_PER_SEC
# endif

#define CPU_CLOCK_IDLE 60
#define CPU_CLOCK_STD 200

# define YAPE_RENDER_NORMAL      0
# define YAPE_LAST_RENDER        0

# define MAX_PATH            256
# define YAPE_MAX_SAVE_STATE    5

  typedef struct YAPE_t {
 
    char yape_save_used[YAPE_MAX_SAVE_STATE];
    char yape_save_name[MAX_PATH];
    char yape_home_dir[MAX_PATH];
    int  yape_speed_limiter;
    int  psp_screenshot_id;
    int  psp_cpu_clock;
    int  psp_joystick_cursor;
    int  yape_snd_enable;
    int  yape_sound_mute;
    int  yape_render_mode;
    int  psp_skip_max_frame;
    int  psp_skip_cur_frame;
    int  psp_active_joystick;

  } YAPE_t;

  extern YAPE_t YAPE;

  extern int  yape_prg_to_load;
  extern char yape_prg_to_load_filename[MAX_PATH];
  extern int  yape_prg_to_load_zip;
  extern int yape_load_prg();

  extern void yape_initialize();


//END_LUDO:
#ifdef __cplusplus
}
#endif

# endif
